import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FSA_GUI
{
    private Fahrscheinautomat fsa;
    private JFrame fenster;
    private JPanel panel;
    private JLabel zeile1;
    private JLabel zeile2;
    private JLabel zeile3;
    private JLabel zeile4;
    private JButton fs1;
    private JButton fs2;
    private JButton fs3;
    private JButton abbruch;
    private JButton weiter;
    private JButton m5;
    private JButton m10;
    private JButton m20;
    private JButton m50;
    private JButton m100;
    private JButton m200;
    private GUIHorcher lauscher;
   
    public FSA_GUI()
    {
        fsa = new Fahrscheinautomat();
        fsa.serviceAktualisieren();
        int s3 = 200;
        Color farbe = new Color(250,250,150);
        lauscher = new GUIHorcher();
        
        fenster = new JFrame("FSA_GUI");
        fenster.setSize(540,500);
        fenster.setVisible(true);
        fenster.setLocation(10,10);
        fenster.setDefaultLookAndFeelDecorated(true);
       
        panel = new JPanel();
        panel.setLayout(null);
        panel.setBackground(farbe);
        
        fenster.getContentPane().add(panel);
        fenster.setVisible(true);
        
        zeile1 = new JLabel("Bitte Fahrschein whlen");
        zeile1.setBounds(200,10,200,50);
        panel.add(zeile1);
        
        zeile2 = new JLabel("");
        zeile2.setBounds(200,80,200,50);
        panel.add(zeile2);
        
        zeile3 = new JLabel("");
        zeile3.setBounds(200,150,200,50);
        panel.add(zeile3);
        
        zeile4 = new JLabel("");
        zeile4.setBounds(200,220,200,50);
        zeile4.setForeground(Color.red);
        panel.add(zeile4);
        
        fs1 = new JButton("FS fr 145 Cent");
        fs1.setActionCommand("fs1");
        fs1.setBounds(10,10,150,50);
        fs1.setBackground(Color.gray);
        fs1.addActionListener(lauscher);
        panel.add(fs1); 
        
        fs2 = new JButton("FS fr 185 Cent");
        fs2.setActionCommand("fs2");
        fs2.setBounds(10,80,150,50);
        fs2.setBackground(Color.gray);
        fs2.addActionListener(lauscher);
        panel.add(fs2); 
        
        fs3 = new JButton("FS fr 220 Cent");
        fs3.setActionCommand("fs3");
        fs3.setBounds(10,150,150,50);
        fs3.setBackground(Color.gray);
        fs3.addActionListener(lauscher);
        panel.add(fs3); 
              
        abbruch = new JButton("Abbruch");
        abbruch.setBounds(10,360,120,50);
        abbruch.setBackground(Color.red);
        abbruch.addActionListener(lauscher);
        panel.add(abbruch);
        abbruch.setVisible(false);
        
        weiter = new JButton("Weiter");
        weiter.setBounds(10,360,120,50);
        weiter.setBackground(Color.green);
        weiter.addActionListener(lauscher);
        panel.add(weiter);
        weiter.setVisible(false);
                
        m5 = new JButton("5 Cent");
        m5.setActionCommand("5");
        m5.setBounds(400,10,120,50);
        m5.setBackground(Color.yellow);
        m5.addActionListener(lauscher);
        panel.add(m5); 
        
        m10 = new JButton("10 Cent");
        m10.setActionCommand("10");
        m10.setBounds(400,80,120,50);
        m10.setBackground(Color.yellow);
        m10.addActionListener(lauscher);
        panel.add(m10); 
        
        m20 = new JButton("20 Cent");
        m20.setActionCommand("20");
        m20.setBounds(400,150,120,50);
        m20.setBackground(Color.yellow);
        m20.addActionListener(lauscher);
        panel.add(m20); 
        
        m50 = new JButton("50 Cent");
        m50.setActionCommand("50");
        m50.setBounds(400,220,120,50);
        m50.setBackground(Color.yellow);
        m50.addActionListener(lauscher);
        panel.add(m50); 
        
        m100 = new JButton("1 Euro");
        m100.setActionCommand("100");
        m100.setBounds(400,290,120,50);
        m100.setBackground(Color.yellow);
        m100.addActionListener(lauscher);
        panel.add(m100); 
        
        m200 = new JButton("2 Euro");
        m200.setActionCommand("200");
        m200.setBounds(400,360,120,50);
        m200.setBackground(Color.yellow);
        m200.addActionListener(lauscher);
        panel.add(m200); 
        
        muenzenVisible(false);
        panel.repaint();
        
   }
  
   private void muenzenVisible(boolean b)
   {
       m5.setVisible(b);
       m10.setVisible(b);
       m20.setVisible(b);
       m50.setVisible(b);
       m100.setVisible(b);
       m200.setVisible(b);
       abbruch.setVisible(b);
       
    }
    
   private void fsVisible(boolean b)
   {
       fs1.setVisible(b);
       fs2.setVisible(b);
       fs3.setVisible(b);
       muenzenVisible(!b);   
    }
   
   public class GUIHorcher implements ActionListener
   {
        boolean angenommen = false;
       
        public void actionPerformed(ActionEvent ereignis)
        {
            if (ereignis.getActionCommand() == "fs1")
            {   fsa.waehleFahrschein(1);
                zeile1.setText("Fahrpreis: "+fsa.getFahrscheinWert()+" Cent");
                fsVisible(false);
                muenzenVisible(true);
            }
            
            else if (ereignis.getActionCommand() == "fs2")
            {   fsa.waehleFahrschein(2);
                zeile1.setText("Fahrpreis: "+fsa.getFahrscheinWert()+" Cent");
                fsVisible(false);
                muenzenVisible(true);
            }
            
            else if (ereignis.getActionCommand() == "fs3")
            {   fsa.waehleFahrschein(3);
                zeile1.setText("Fahrpreis: "+fsa.getFahrscheinWert()+" Cent");
                fsVisible(false);
                muenzenVisible(true);
            }
            
            else if (ereignis.getActionCommand() == "5")
            {   angenommen=fsa.muenzEinwurf(5);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "10")
            {   angenommen=fsa.muenzEinwurf(10);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "20")
            {   angenommen=fsa.muenzEinwurf(20);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "50")
            {   angenommen=fsa.muenzEinwurf(50);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "100")
            {   angenommen=fsa.muenzEinwurf(100);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "200")
            {   angenommen=fsa.muenzEinwurf(200);
                zeile2.setText("Bereits gezahlt: "+fsa.getSumme()+" Cent");
            }
            
            else if (ereignis.getActionCommand() == "Abbruch")
            {   
                fsa.abbrechen();
                muenzenVisible(false);
                abbruch.setVisible(false);
                weiter.setVisible(true);
                zeile2.setText("Ihr Geld wurde ausgegeben");
                zeile3.setText("Vorgang abgebrochen");
                zeile4.setText("");
                return;
                    
                
            } 
            
            else if (ereignis.getActionCommand() == "Weiter")
            {   
                fsa.clear();
                weiter.setVisible(false);
                fsVisible(true);
                //fsa.reset();
                zeile1.setText("Bitte Fahrschein whlen");
                zeile2.setText("");
                zeile3.setText("");
                zeile4.setText("");
                //abbruch.setVisible(true);
                angenommen = false;
                //panel.repaint();
            }
            
            // Hier folgt die Bearbeitungslogik, die nur nach dem Einwurf einer Mnze
            // ausgefhrt werden darf
            if (angenommen) // die Mnze wurde angenommen
            {
                if (fsa.summeVerarbeiten()) // Fahrschein wurde gedruckt
                {
                    muenzenVisible(false);
                    zeile2.setText("Wechselgeld wurde ausgegeben");
                    zeile3.setText("Fahrschein wurde gedruckt");
                    abbruch.setVisible(false);
                    weiter.setVisible(true);
                }
                else
                {
                     zeile3.setText("Noch zahlen: "+fsa.nochZuZahlen()+" Cent");
                }
            }
            else // Mnze nicht angenommen
            {
                if (fsa.passendZahlen())  zeile4.setText("Passend Zahlen");
            }
            if (!fsa.bereit())
            {
                
                fsVisible(false);
                muenzenVisible(false);
                abbruch.setVisible(false);
                weiter.setVisible(false);
                zeile1.setText("Automat auer Betrieb!");
                zeile2.setText("");
                zeile3.setText("");
                zeile4.setText("");
            }
                
            fsa.serviceAktualisieren(); //service_GUI aktualisieren       
     
        }// end action performed
           
    }// GUIHorcher
    
    public static void main(String[] args)
    {
        new FSA_GUI();
    } // main
    
}
