/**
 * Klasse zur Modellierung einer Geldkassette.
 * @author R.Punkenburg 
 * @version 22.1.2006
 */
public class Geldkassette
{
    private int inhalt; // aufsummierter Wert der Mnzen
    
    /**
     * Konstruktor fr Objekte der Klasse Geldkassette;
     * Bei der Instanzierung ist die Geldkassette leer
     * @param  typ     Sorte der Mnzen im Schacht
     */
    public Geldkassette()
    {
        inhalt = 0;
    }
        
    /**
     * Methode zum Abfragen des Inhaltes der Geldkassette
     * @return    aufsummierter Wert der Mnzen in der Geldkassette
     */
    public int getInhalt()
    {
        return inhalt;
    } // getInhalt
    
    /**
     * Methode zum Erhhen des Inhaltes der Geldkassette
     */
    public void aufstocken(int wert)
    {
        inhalt += wert;
    } // aufstocken
  
} // Geldkassettte
