/**
 * Klasse zur Modellierung eines Fahrscheindruckers eines Fahrkartenautomaten
 * 
 * @author R.Punkenburg
 * @version 2.2.2006
 */
public class Drucker
{
    private int leerFormulare;
    private Drucker_GUI drucker_GUI;
    /**
     * Konstruktor fr Objekte der Klasse Drucker
     */
    public Drucker()
    {
        leerFormulare = 5;
        drucker_GUI = new Drucker_GUI();
    }

    /**
     * Methode zum Drucken eines Fahrscheines
     * @param preis der Preis des Fahrscheines
     */
    public void druckeFahrschein(int preis)
    {
         drucker_GUI.zeigeFS(preis);
         //System.out.println("Drucker: =====================================");
         //System.out.println("Drucker: =========== Ihr Fahrschein ==========");
         //System.out.println("Drucker:             Preis : "+preis+" Cent");
         //System.out.println("Drucker: =====================================");
         leerFormulare--;
    } // druckeFahrschein
    
    /**
     * Methode zum Prfen, ob keine Fahrscheinformulare mehr vorhanden sind
     * @return true, falls keine Fahrscheinformulare mher vorhanden sind, sonst false
     */
    public boolean leer()
    {
        return (leerFormulare==0);
    } // bereit
    
    public void clear()
    {
        drucker_GUI.clear();
    }
    
    public int getLeerFormulare()
    {
        return leerFormulare;
    }
    
    public void setLeerFormulare()
    {
        leerFormulare = 7;
    }
    

       
       
       
       
    
} // class Drucker
