import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Klasse Service_GUI
 * 
 * @author R. Punkenburg 
 * @version 17.2.2006
 */
public class Service_GUI
{
    private JFrame fenster;
    private JPanel panel;
    private JLabel[] zeilen;
    private JButton reset;
    private GUIHorcher lauscher;
    private Fahrscheinautomat fsa;
    Color farbe = new Color(250,250,150);
   
    public Service_GUI(Fahrscheinautomat fsa)
    {
        this.fsa = fsa;
        fenster = new JFrame("Service_GUI");
        fenster.setSize(250,400);
        fenster.setVisible(true);
        fenster.setLocation(560,10);
        
        panel = new JPanel();
        panel.setLayout(null);
        panel.setBackground(Color.white);

        fenster.getContentPane().add(panel);
        fenster.setVisible(true);
        
        lauscher = new GUIHorcher();
        
        reset = new JButton("Drucker auffllen");
        reset.setBounds(10,300,200,50);
        reset.setBackground(farbe);
        reset.addActionListener(lauscher);
        panel.add(reset);
        reset.setVisible(true);
        
        zeilen = new JLabel[8];
        for (int i = 0; i<8;i++)
        {
            zeilen[i] =new JLabel("");
            zeilen[i].setBounds(10,30*i,130,20);
            panel.add(zeilen[i]);
        }
        panel.repaint();
        
              
    }
    /**
     * Den "Zustand" des Fahrscheinautomaten Zeilenweise anzeigen
     * @param i die Nummer der Zeile
     * @param text der Text der Zeile
     */
    public void zeige(int i, String text) 
    {
        zeilen[i].setText(text);
    } // zeige
    
    /**
     * Das Panel lschen
     */
    public void clear()
    {       
    } // clear
    
     public class GUIHorcher implements ActionListener
     {
        public void actionPerformed(ActionEvent ereignis)
        {
            if (ereignis.getActionCommand() == "Drucker auffllen")
            { 
                fsa.drucker.setLeerFormulare();
                fsa.serviceAktualisieren();
            }
        }
    }
}
        


   
    

